--[[
    Description: Random Velocity (力度随机)
    Version: 1.0.0
    Author: zaibuyidao (再補一刀)
    Website: https://www.soundengine.cn/user/%E5%86%8D%E8%A3%9C%E4%B8%80%E5%88%80
    Donation: http://www.paypal.me/zaibuyidao
--]]

function Main()
  local take = reaper.MIDIEditor_GetTake(reaper.MIDIEditor_GetActive())
  retval, notes, ccs, sysex = reaper.MIDI_CountEvts(take)
  userOK, dialog_ret_vals = reaper.GetUserInputs("Random Velocity", 2, "Min Velocity,Max Velocity", "1,100")
  if not userOK then return reaper.SN_FocusMIDIEditor() end
  min_vel, max_vel = dialog_ret_vals:match("(.*),(.*)")
  min_vel, max_vel = tonumber(min_vel), tonumber(max_vel)

  if min_vel > 127 then
    min_vel = 127
  elseif
    min_vel < 1 then
    min_vel = 1
  elseif
    max_vel > 127 then
    max_vel = 127
  elseif
    max_vel < 1 then
    max_vel = 1
  elseif
  min_vel > max_vel then
    local t = max_vel
    max_vel = min_vel
    min_vel = t
  end

  if min_vel == max_vel then 
    return reaper.MB("Random interval is empty, please re-enter", "Error", 0),
           reaper.SN_FocusMIDIEditor()
  end

  local diff = max_vel - min_vel

  for i = 0,  notes-1 do
    retval, sel, muted, ppq_start, ppq_end, chan, pitch, vel = reaper.MIDI_GetNote( take, i )
    if sel == true then
      vel = tonumber(min_vel + math.random(diff))
      reaper.MIDI_SetNote( take, i, sel, muted, ppq_start, ppq_end, chan, pitch, vel, true )
    end
    i=i+1
  end
  reaper.UpdateArrange()
end

script_title = "Random Velocity"
reaper.Undo_BeginBlock()
Main()
reaper.Undo_EndBlock(script_title, -1)
reaper.SN_FocusMIDIEditor()
