--[[
    Description: Sustain Pedal (延音踏板)
    Version: 1.0.1
    Author: zaibuyidao (再補一刀)
    Website: https://www.soundengine.cn/user/%E5%86%8D%E8%A3%9C%E4%B8%80%E5%88%80
    Donation: http://www.paypal.me/zaibuyidao
--]]

interval = 1920 -- 重复间隔. 480tick下每小节1920, 960tick下每小节3840. 
selected = false

local retval, userInputsCSV = reaper.GetUserInputs("Sustain Pedal", 5, "CC Number,On:0-63,Off:64-127,Repetition,Offset", "64,127,0,10,-20")
if not retval then return reaper.SN_FocusMIDIEditor() end
local controller, cc_begin, cc_end, cishu, offset = userInputsCSV:match("(.*),(.*),(.*),(.*),(.*)")
controller, cc_begin, cc_end, cishu, offset = tonumber(controller), tonumber(cc_begin), tonumber(cc_end), tonumber(cishu), tonumber(offset)

function HoldPedalOn()
  local take = reaper.MIDIEditor_GetTake(reaper.MIDIEditor_GetActive())
  if take == nil then return end
  local pos = reaper.GetCursorPositionEx(0)
  local ppq = reaper.MIDI_GetPPQPosFromProjTime(take, pos)
  ppq = ppq - interval
  for i = 1, cishu do
    ppq = ppq + interval
    reaper.MIDI_InsertCC(take, selected, false, ppq, 0xB0, 0, controller, cc_begin)
    i=i+1
  end
end

function HoldPedalOff()
  local take = reaper.MIDIEditor_GetTake(reaper.MIDIEditor_GetActive())
  if take == nil then return end
  local pos = reaper.GetCursorPositionEx(0)
  local ppq = reaper.MIDI_GetPPQPosFromProjTime(take, pos)
  ppq = ppq + offset -- 释放偏移量
  for i = 1, cishu do
    ppq = ppq + interval
    reaper.MIDI_InsertCC(take, selected, false, ppq, 0xB0, 0, controller, cc_end)
    i=i+1
  end
end

reaper.Undo_BeginBlock()
HoldPedalOn()
HoldPedalOff()
reaper.UpdateArrange()
reaper.Undo_EndBlock("Sustain Pedal", -1)
reaper.SN_FocusMIDIEditor()
